/*-
 * Copyright (c) 2006 Allan Saddi <allan@saddi.com>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: wsgitypes.h 2221 2006-12-12 20:38:51Z asaddi $
 */

#ifndef APS_WSGITYPES_H
#define APS_WSGITYPES_H

#include <Python.h>
#include "ajp.h"

typedef struct {
  PyObject_HEAD
  /* All fields are private */
  AJPContext *context;
  PyObject *environ;
  PyObject *input;
  PyObject *status;
  PyObject *headers;
  PyObject *result;
  int headers_sent;
} Request;

struct InputStream_chunk {
  struct InputStream_chunk *next;
  int size;
};

#define InputStream_chunk_DATA(chunk) ((char *)&((struct InputStream_chunk *)chunk)[1])

typedef struct {
  PyObject_HEAD
  PyObject *request;
  int pos, size, avail;
  struct InputStream_chunk *chunks, *tail;
} InputStream;

extern PyTypeObject Request_Type;
extern PyTypeObject InputStream_Type;

PyObject *wsgiMapAJPError(int error);

#endif /* APS_WSGITYPES_H */
